unit mouse;
interface

function  InitMouse:word;
procedure SetHandler;
procedure ResetHandler;
procedure DisplayPointer;
procedure HidePointer;
procedure LocatePointer(XPos,YPos:integer);
procedure SetRange(MinXPos,MinYPos,MaxXPos,MaxYPos:integer);
procedure CorrectChar;
function  CheckMouse:word;
function  CheckAdapter:word;

var    XMouse,YMouse,Keys:word;
const  FontCode  : array[0..3] of byte=($D1,$D2,$D3,$D4);

implementation

{ࠦ }
const ORMask : array[0..15] of byte =($00,$40,$60,$70,$78,$7C,$7E,$7E,
                                      $78,$4C,$0C,$04,$06,$06,$00,$00);
      ANDMask: array[0..15] of byte =($3F,$5F,$6F,$77,$7B,$7D,$7E,$7E,
                                      $79,$4D,$2D,$F4,$F6,$F6,$F0,$FF);
{ࠧ ᨬ   0B0h ''}
      CharB0h: array[0..15] of byte =($88,$22,$88,$22,$88,$22,$88,$22,
                                      $88,$22,$88,$22,$88,$22,$88,$22);


{ ࠭ ࠦ ᨬ}
var   CharGenBuffer :array[0..19*8-1] of byte;

 PortFlags         : word;
 VisibleCount      : word;   {稪                   }
{ࠬ ࠭}
 VideoSeg          : word;   {ᥣ                       }
 VideoOffset       : word;   {ᬥ饭 ⥪饩 ࠭     }
 BytesPerChar      : byte;   {ࠧ ᨬ   (14  16)}
 ScreenRows        : byte;   {ᨬ 冷    ࠭       }
 ScreenColumns     : byte;   {ᨬ   ࠭       }
 ScrWidthInBytes   : word;   {ਭ ࠭               }

{न }
 XMouse2           : word;
 YMouse2           : word;

{⥪騩 ViewPort -  ६饭 }
 CoordXMax         : word;
 CoordXMin         : word;
 CoordYMax         : word;
 CoordYMin         : word;
{䨧᪨ ࠭ ࠭,  ᥫ}
 TopScrMargin      : word;
 LeftScrMargin     : word;
 ScrWidthInPixels  : word;
 ScrHeightInPixels : word;
{ ࠭ ᨬ  ࠭}
 CharCodeBuff1     : word;
 CharCodeBuff2     : word;
 PosInCell         : byte;
var
 LastHorizDist     : word;
 LastVertDist      : word;


procedure PortProgr1;near;assembler;
asm
                         mov    dx,03C4h
                         mov    ax,0402h
                         out    dx,ax
                         mov    ax,0704h
                         out    dx,ax
                         mov    dx,03CEh
                         mov    ax,0005h
                         out    dx,ax
                         mov    ax,0406h
                         out    dx,ax
                         mov    ax,0204h
                         out    dx,ax
end;

procedure PortProg2;near;assembler;
asm
                         mov    dx,03C4h
                         mov    ax,0302h
                         out    dx,ax
                         mov    ax,0304h
                         out    dx,ax
                         mov    dx,03CEh
                         mov    ax,1005h
                         out    dx,ax
                         mov    ax,[PortFlags]
                         out    dx,ax
                         mov    ax,0004h
                         out    dx,ax
end;


{ 뫠 ࠧ ᨬ AL   ᨬ BL  
  뫠 ࠧ ᨬ AH   ᨬ BH  
  BP=ࠧ ࠧ ᨬ   (BytesPerChar)
  DS=ES=0A000h
   DX,SI,DI}
procedure CopyTwoCharImage;near;assembler;
asm
                         push   cx
                         call   @CopyCharImage
                         push   dx
                         mov    al,ah
                         mov    bl,bh
                         call   @CopyCharImage
                         mov    di,dx
                         pop    si
                         pop    cx
                         ret

 {뫠 ࠧ ᨬ AL   ᨬ BL  
  BP=ࠧ ࠧ ᨬ   (BytesPerChar)
  DS=ES=0A000h
   DX,CX,SI,DI }
     @CopyCharImage:     mov    dl,al   { si:=al*32}
                         xor    dh,dh   { di:=bl*32}
                         mov    cl,5    { cx:=bp   }
                         shl    dx,cl   { rep movsb}
                         mov    si,dx

                         mov    dl,bl
                         xor    dh,dh
                         shl    dx,cl
                         mov    di,dx
                         mov    cx,bp
                         rep    movsb
                         ret

end;

{      ; DH = Ycoord / BytesPerChar
       ;[PosInCell] ; ⮪ ।饣 
       ; DL = Xcoord / 8                 }
procedure CalcScreenAddr;near;assembler;
asm
                         push   bx
                         push   ax
                         mov    ax,[ScrWidthInBytes]
                         mul    dh   {YC*Width+XC*2}
                         mov    di,dx
                         and    di,00FFh
                         add    di,di
                         add    di,ax
                         add    di,[VideoOffset]
                         mov    ax,[VideoSeg]
                         mov    es,ax
                         pop    ax    {ES:DI=>   }
                         pop    bx    {                              }
end;

{ ࠭塞 ᮤন  
  DH=YC
  DL=XC}
procedure SaveCharsFromVideoBuff;near;assembler;
asm
                         call   CalcScreenAddr  { 塞 }
                         mov    al,es:[di]      {  ᮤন }
                         mov    ah,es:[di+02]   { ( ᬥ ᨬ)}
                         mov    [CharCodeBuff1],ax   { ࠭塞}
                         add    di,[ScrWidthInBytes] {६頥  ᫥.ப}
                         mov    al,es:[di]      {  ᬥ ᨬ}
                         mov    ah,es:[di+02]
                         mov    [CharCodeBuff2],ax
end;

{ AL =  ࢮ ᨬ     AL  AH
  AH =  ண ᨬ     BL  BH
  BL =  쥣 ᨬ
  BH =  ⢥⮣ ᨬ
  DH=YC
  DL=XC  }
procedure PutCharsToVideoBuff;near;assembler;
asm
                         call   CalcScreenAddr  {塞 }
                         mov    es:[di],al      {뢠  ࢮ ᨬ}
                         cmp    dl,[ScreenColumns] {諨  ࠭  X?}
                         je     @@1             {}
                         mov    es:[di+02],ah   {뢠  ண ᨬ}
                    @@1: cmp    dh,[ScreenRows] {諨  ࠭  Y}
                         je     @@2             {}
                         add    di,[ScrWidthInBytes] {室  ᫥.ப}
                         mov    es:[di],bl      {堥   ᨬ}
                         cmp    dl,[ScreenColumns]
                         je     @@2
                         mov    es:[di+02],bh
                    @@2:
end;

{  DX= Xcoord
   BX= Ycoord}
procedure ConvertPixelsToCell;near;assembler;
asm
                         mov    cl,3
                         shr    dx,cl     { Xcoord / 8}
                         mov    cl,[BytesPerChar]
                         mov    ax,bx     { Ycoord / BytesPerChar}
                         div    cl
                         mov    dh,al     { DH = Ycoord / BytesPerChar}
                         mov    [PosInCell],ah {; ⮪ ।饣 }
end;                                      { DL = Xcoord / 8}


{;뢠 ࠦ   ࠦ ४ ᨬ}
procedure MakeCursorView;near;assembler;
asm
                         push   dx
                         push   ds
                         push   bp
                         mov    bp,word ptr [BytesPerChar]
                         and    bp,00FFh
                         mov    dx,SegA000
                         mov    ds,dx
                         mov    es,dx
                         call   CopyTwoCharImage
                         pop    bp
                         pop    ds
                         pop    dx
                         add    si,dx
                         add    di,dx
                   @@1:  or     ch,ch
                         je     @@2
                         mov    ah,byte ptr ds:ORMask[bp]
                         xor    al,al
                         mov    dh,byte ptr ds:ANDMask[bp]
                         mov    dl,0FFh
                         shr    ax,cl
                         stc
                         rcr    dx,cl
                         and    es:[si],dh
                         and    es:[di],dl
                         or     es:[si],ah
                         or     es:[di],al
                         inc    bp
                         inc    si
                         inc    di
                         dec    ch
                         jmp    @@1
                   @@2:
end;

  {;ᮢ    }
procedure ShowMouseCursor;near;assembler;
asm
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         push   dx
                         call   ConvertPixelsToCell
                         call   SaveCharsFromVideoBuff
                         pop    cx
                         and    cl,7
                         push   dx
                          call   PortProgr1
                          mov    ax,[CharCodeBuff1]
                          mov    bx,word ptr [FontCode]
                          xor    bp,bp
                          mov    dl,[PosInCell]
                          xor    dh,dh
                          mov    ch,[BytesPerChar]
                          sub    ch,dl
                          call   MakeCursorView
                          mov    ax,[CharCodeBuff2]
                          mov    bx,word ptr [FontCode+2]
                          mov    ch,[PosInCell]
                          xor    dx,dx
                          call   MakeCursorView
                          call   PortProg2
                         pop    dx
                         mov    ax,word ptr [FontCode]
                         mov    bx,word ptr [FontCode+2]
                         call   PutCharsToVideoBuff
end;
{    ண    XMouse, YMouse
    DX = XMouse2
    BX = YMouse2}
procedure HideMouseCursor;near;assembler;
asm
                         call   ConvertPixelsToCell
                         mov    ax,[CharCodeBuff1]
                         mov    bx,[CharCodeBuff2]
                         call   PutCharsToVideoBuff
end;



{ ;࠭ ࠧ  ᨬ  
 ;:    DS=VideoSeg
 ;       BX=᫮   뫪=BytesPerChar
 ;       DL,DH= ᨬ
 ;       ES:DI=>  ࠧ ᨬ}

procedure SaveTwoCharImage;near;assembler;
asm
                         mov    al,dl
                         call   @SaveCharImage
                         mov    al,dh
                         call   @SaveCharImage
                         ret

{  ;࠭ ࠧ ᨬ  
  ;:   DS=VideoSeg
  ;      BX=᫮   뫪=BytesPerChar
  ;      AL= ᨬ
  ;      ES:DI=>  ࠧ ᨬ}

         @SaveCharImage: xor    ah,ah
                         mov    cl,05
                         shl    ax,cl
                         mov    si,ax
                         mov    cx,bx
                         rep   movsb
                         ret
end;

{  ;頥  ᨬ  
  ;: ES=VideoSeg
  ;    DS:SI=> ࠧ ᨬ
  ;    BX=BytesPerChar
  ;     DL=FontCode   ᨬ, ࠧ  㤥 饭
  ;     DH=FontCode+1}
procedure PutTwoCharImage;near;assembler;
asm
                         mov    al,dl
                         call   @PutCharImage
                         mov    al,dh
                         call   @PutCharImage
                         ret

{  ;頥 ࠧ ᨬ  
  ;:   ES=VideoSeg
  ;      BX=᫮   뫪=BytesPerChar
  ;      AL= ᨬ
  ;      DS:SI=> ࠧ ᨬ}
         @PutCharImage:
                         xor    ah,ah
                         mov    cl,05
                         shl    ax,cl
                         mov    di,ax
                         mov    cx,bx
                         rep movsb
                         ret
end;

{;ࠡ稪 뢠  }
procedure Mouse_Handler;far;assembler;
asm
                         push   ds
                         pushf
                         cld
                         cli
                         mov    dx,SEG @DATA
                         mov    ds,dx
                         mov    [Keys],bx         { }
                         mov    dx,[LastHorizDist]{।饥  }
                         mov    bx,[LastVertDist]
                         cmp    si,dx
                         jne    @@1
                         cmp    di,bx
                         je     @@exit
                    @@1: mov    [LastHorizDist],si
                         mov    [LastVertDist],di
                         sub    si,dx
                         sub    di,bx
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         push   dx
                         push   bx
                         add    dx,si
                         add    bx,di
                         cmp    dx,[CoordXMin]
                         jnl    @@2
                         mov    dx,[CoordXMin]
                    @@2: cmp    dx,[CoordXMax]
                         jle    @@3
                         mov    dx,[CoordXMax]
                    @@3: cmp    bx,[CoordYMin]
                         jnl    @@4
                         mov    bx,[CoordYMin]
                    @@4: cmp    bx,[CoordYMax]
                         jle    @@5
                         mov    bx,[CoordYMax]
                    @@5: mov    [XMouse2],dx
                         mov    [YMouse2],bx
                         mov    [XMouse],dx
                         mov    [YMouse],bx
                         pop    bx
                         pop    dx
                         cmp    word ptr [VisibleCount],0
                         jne    @@exit
                         call   HideMouseCursor
                         call   ShowMouseCursor
                  @@exit:
                         popf
                         pop    ds
end;


{        AX= Xcoord
         BX= Ycoord}
procedure MoveCursorTo;near;assembler;
asm
                         cmp    [CoordXMax],ax
                         jb     @@exit
                         cmp    ax,[CoordXMin]
                         jb     @@exit
                         cmp    [CoordYMax],bx
                         jb     @@exit
                         cmp    bx,[CoordYMin]
                         jb     @@exit
                         cmp    word ptr [VisibleCount],0
                         je     @@1
                         call   @SaveNewCoord
                         jmp    @@exit
                    @@1:
                         push   ax
                         push   bx
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor  {;   ண }
                         pop    bx
                         pop    ax
                         call   @SaveNewCoord
                         call   ShowMouseCursor  {;ᮢ    }
                 @@exit:
                         ret

{  AX= Xcoord
   BX= Ycoord}
          @SaveNewCoord:
                         mov    [XMouse2],ax
                         mov    [YMouse2],bx
                         mov    [XMouse],ax
                         mov    [YMouse],bx
                         ret
end;

{ AX= Xmax
  CX= Xmin}
procedure SetXrange;near;assembler;
asm
                         cmp    ax,cx
                         jnl    @@0
                         xchg   cx,ax
                    @@0: cmp    [ScrWidthInPixels],ax
                         jnb    @@1
                         mov    ax,[ScrWidthInPixels]
                    @@1: cmp    cx,[LeftScrMargin]
                         jnb    @@2
                         mov    cx,[LeftScrMargin]

                    @@2: mov    [CoordXMin],cx
                         mov    [CoordXMax],ax

                         cmp    ax,[XMouse2]
                         jnb    @@3
                         mov    bx,[YMouse2]
                         call   MoveCursorTo
                         jmp    @@4
                    @@3:
                         cmp    [XMouse2],cx
                         jnb    @@4
                         mov    bx,[YMouse2]
                         mov    ax,cx
                         call   MoveCursorTo
                   @@4:
end;

{ AX= Ymax
  CX= Ymin}
procedure SetYRange;near;assembler;
asm
                         cmp    ax,cx
                         jnl    @@0
                         xchg   cx,ax
                    @@0: cmp    [ScrHeightInPixels],ax
                         jnb    @@1
                         mov    ax,[ScrHeightInPixels]
                    @@1: cmp    cx,[TopScrMargin]
                         jnb    @@2
                         mov    cx,[TopScrMargin]

                    @@2: mov    [CoordYMin],cx
                         mov    [CoordYMax],ax
                         cmp    ax,[YMouse2]
                         jnb    @@3
                         mov    bx,ax
                         mov    ax,[XMouse2]
                         call   MoveCursorTo
                         jmp    @@4
                    @@3:
                         cmp    [YMouse2],cx
                         jnb    @@4
                         mov    ax,[XMouse2]
                         mov    bx,cx
                         call   MoveCursorTo
                   @@4:
end;


procedure SetHandler;assembler;
asm
                         push   bp
                         push   cs
                         pop    es
                         mov    cx,001Fh
                         mov    dx,offset Mouse_Handler
                         mov    ax,000Ch
                         int    33h
                         mov    ax,000Bh
                         int    33h
                         pop    bp
end;

procedure DisplayPointer;assembler;
asm
                         push   ds
                         push   bp
                         cli
                         cmp    word ptr [VisibleCount],0
                         je     @@1
                         inc    word ptr [VisibleCount]
                         cmp    word ptr [VisibleCount],0
                         jne    @@1
                         call   ShowMouseCursor
                    @@1: sti
                         pop    bp
                         pop    ds
end;

procedure HidePointer;assembler;
asm
                         push   ds
                         cli
                         dec    word ptr [VisibleCount]
                         cmp    word ptr [VisibleCount],-1
                         jne    @@1
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor
                    @@1: sti
                         pop    ds
end;

function InitMouse;assembler;
asm
                         push   ds
                         push   bp
                         mov    [Keys],0
                         xor    bh,bh
                         mov    ax,1130h
                         int    10h
                         mov    [BytesPerChar],cl
                         push   cx
                         mov    [ScreenRows],dl
                         mov    ax,cx
                         mul    dl
                         add    ax,cx
                         sub    ax,6
                         mov    [ScrHeightInPixels],ax  {ax= ࠭  ᪠-ப}
                         mov    [CoordYMax],ax
                         xor    cx,cx
                         mov    [TopScrMargin],cx
                         mov    [CoordYMin],cx
                         shr    ax,1
                         mov    [YMouse2],ax
                         mov    [YMouse],ax
                         mov    ah,0Fh
                         int    10h
                         mov    cl,ah        {ah=ScreenColumns}

                         mov    di,0E06h
                         mov    si,SegB800
                         cmp    al,7         {al=VideoMode}
                         jne    @@1
                         mov    si,SegB000
                         mov    di,0A06h
                   @@1:
                         mov    [VideoSeg],si
                         mov    [PortFlags],di

                         mov    al,ah
                         xor    ah,ah
                         add    ax,ax
                         mov    [ScrWidthInBytes],ax
                         mul    dl
                         mul    bh
                         mov    [VideoOffset],ax
                         dec    cl
                         mov    [ScreenColumns],cl
                         mov    ax,8
                         mul    cl
                         add    ax,5
                         mov    [ScrWidthInPixels],ax
                         mov    [CoordXMax],ax
                         xor    cx,cx
                         mov    [LeftScrMargin],cx
                         mov    [CoordXMin],cx
                         shr    ax,1
                         mov    [XMouse2],ax
                         mov    [XMouse],ax
                         mov    di,offset CharGenBuffer
                        push   ds
                         push   ds
                         pop    es
                         mov    bl,[BytesPerChar]
                         xor    bh,bh
                         mov    ax,SegA000
                         mov    ds,ax
                          cli
                          call   PortProgr1
                          mov    dx,word ptr es:[FontCode]
                          call   SaveTwoCharImage
                          mov    dx,word ptr es:[FontCode+2]
                          call   SaveTwoCharImage
                          call   PortProg2
                          sti
                        pop    ds
                         mov    ax,000Bh
                         int    33h
                         mov    word ptr [VisibleCount],-1
                         pop    ax
                         pop    bp
                         pop    ds
end;

procedure ResetHandler;assembler;
asm
                         push   ds
                         push   bp
                         xor    cx,cx
                         mov    ax,000Ch
                         int    33h
                         cmp    word ptr [VisibleCount],0
                         jne    @@1
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor
                    @@1: mov    si,offset CharGenBuffer
                         mov    dx,SegA000
                         mov    es,dx
                         mov    bl,[BytesPerChar]
                         sub    bh,bh
                         call   PortProgr1
                           mov    dx,word ptr [FontCode]
                           call   PutTwoCharImage
                           mov    dx,word ptr [FontCode+2]
                           call   PutTwoCharImage
                         call   PortProg2
                         pop    bp
                         pop    ds
end;

procedure LocatePointer;assembler;
asm
                         push   ds
                         mov    ax,[XPos]
                         mov    bx,[YPos]
                         call   MoveCursorTo
                         pop    ds
end;

procedure SetRange;assembler;
asm
                         push   ds
                         mov    ax,[MaxXPos]
                         mov    cx,[MinXPos]
                         push   bp
                         call   SetXRange
                         pop    bp
                         mov    ax,[MaxYPos]
                         mov    cx,[MinYPos]
                         call   SetYRange
                         pop    ds
end;

function CheckMouse;assembler;
asm
                         push   ds
                         mov    ax,3533h
                         int    21h
                         xor    ax,ax
                         mov    cx,es
                         or     cx,bx
                         je     @@2
                         cmp    byte ptr es:[bx],0CFh {஢ઠ  IRET}
                         je     @@2
                         inc    ax
                    @@2: pop    ds
end;


function CheckAdapter;assembler;
asm
                         push   bp
                         xor    bx,bx
                         mov    ax,1A00h
                         int    10h
                         cmp    al,1Ah
                         jne    @@1
                         cmp    bl,07
                         je     @@2
                         cmp    bl,08
                         je     @@2
                    @@1: mov    bl,10h
                         mov    ah,12h
                         int    10h
                         cmp    bl,10h
                         je     @@3
                         mov    ax,Seg0040
                         mov    es,ax
                         test   byte ptr es:[87h],08
                         jne    @@4
                    @@3: xor    ax,ax
                         jmp    @@5
                    @@4: mov    ax,0001
                         jmp    @@5
                    @@2: mov    ax,0002
                    @@5:
                         pop    bp
end;

procedure CorrectChar;assembler;
asm
                         mov    si,offset CharB0h
                         mov    di,0B0h*32
                         mov    ax,SegA000
                         mov    es,ax
                         mov    cl,[BytesPerChar]
                         xor    ch,ch
                         cld
                         cli
                         call   PortProgr1
                         rep    movsb
                         call   PortProg2
                         sti
end;

end.

